/**
 * @file
 * Provides Splidebox AJAX.
 */

(function ($, Drupal, drupalSettings, _ds) {

  'use strict';

  var _idOnce = 'sboxAjax';
  var _ajax = 'is-sbox-ajax';
  var _ajaxElement = '.' + _ajax;

  var SplideboxAjax = function (Splide, Components) {
    var root = Splide.root;
    var splidebox = drupalSettings.splidebox || {};
    var timeOut = splidebox.lightbox ? splidebox.lightbox.ajaxTimeout : 600;

    return {
      mount: function () {
        var me = this;

        Splide.on('mounted.sba', me.ajax.bind(me));

        Splide.on('active.sba', me.load.bind(me));

      },

      // @todo refactor or remove post #3031444, #3026636.
      ajax: function () {
        var me = this;

        // Wait for the dynamically-added slides.
        // if (once(_id, _ajaxElement, root).length) {
        // once.remove(_id, _ajaxElement, root);
        // }
        // @todo use Promise for more reliable sequence.
        setTimeout(function () {
          me._ajax();
        }, 300);
      },

      // @todo refactor or remove post #3031444, #3026636.
      init: function (el) {
        var base = el.id;
        var opts = {
          base: base,
          element: el,
          wrapper: base
        };

        var href = el.href;
        if (href) {
          opts.url = href;
          opts.event = 'click';

          Drupal.ajax(opts);
        }
      },

      // @todo refactor or remove post #3031444, #3026636.
      _ajax: function () {
        var me = this;
        $.once(me.init.bind(me), _idOnce, _ajaxElement, root);
      },

      load: function (slide) {
        setTimeout(function () {
          var el = $.find(slide.slide, _ajaxElement);

          if ($.isElm(el) && !$.hasClass(el, _ajax + '-hit')) {
            // @todo remove post #3031444, #3026636.
            $.on(el, 'click', function (e) {
              e.preventDefault();
              e.stopPropagation();
            }, false);

            el.click();

            $.addClass(el, _ajax + '-hit');
          }
        }, timeOut);
      }

    };
  };

  _ds.extend({
    SplideboxAjax: SplideboxAjax
  });

})(dBlazy, Drupal, drupalSettings, dSplide);
